;---------------------------------------------------------------------------
;************** GreyLib version 1.1 (C) 1997 by Dines Justesen**************
;---------------------------------------------------------------------------
; This a greyscake library for the TI82, which supports both 4 and 8 shades
; of grey. Below os a short definition of what the library needs, and which
; function it includes. For an example of how to use the library see
; GreyTest.
;
; Because the TI82 uses a display controller and not a memory mapped display
; like the ti85, greyscale on the TI82 is alot slower. Therefore the grey-
; scale pictures does notlooks as good as on the TI85. But have a look at
; what you can do, a see if you like it anyway.
;
; You are welcome to use this library in your own program as long as you
; give me the credit for my work. Just on line mentioning my name and that
; the rutine came from GreyLib, that is all.
;
; Dines Justesen
;---------------------------------------------------------------------------
; Definitions used:
;     USE_8_SHADES : If defined the uses three pictures to make 8 shades of
;                    grey. Otherwise it use two pictures to make 4 shades.
;     USE_85_PIC : If defined the library uses pictures in the format used
;                  by the TI85. This is included show pictures made for TI85
;                  programs can be view without problems.
;     CHECK_VBI : Normally the display is updated on every interrupt, but if
;                 CHECK_VBI is defined it will only by updated on VBI inter-
;                 rupts.
;     FAST_UPDATE : Because the TI82 uses a display controller, greyscale is
;                   not very fast, therefor the display is normally only up-
;                   dated on every 2nd/4th interrupt. If FAST_UPDATE is
;                   defined the display will be updated on every /every 2nd
;                   interrupt.
; Data used:
;     Counter : 8583
; Data needed:
;     Pic1 : Pointer to bitmap containing MSBs
;     Pic2 : Pointer to bitmap containing LSBs if 4 shades, otherwise middle bit.
;     Pic3 : Only need when using 8 shades, pointer to bitmap containgin LSBs.
; Functions:
;     GreyScaleOn: Start the greyscale
;     GreyScaleOff: Stops it
;----------------------------------------------------------------------------

;----------------------------------------------------------------------------
; Data
;----------------------------------------------------------------------------

Counter = $8583                       ; Counter in start of graph mem
