.nolist
; Menu include file

DisplayMenu:
	ld c, 1
	push bc
	push de
	push hl			; Save the parameters
	ROM_CALL(CLEARLCD)
	set 3, (iy+05)		; Choose inverse text
	ld hl, $0000
	ld (CURSOR_POS), hl	; Move cursor to 0, 0
	pop hl
	ROM_CALL(D_ZT_STR)	; Display menu title
	ld hl, $0001
	ld (CURSOR_POS), hl	; Move cursor to 0, 1
	res 3, (iy+05)		; Choose normal text
	pop de
	ld h, d
	ld l, e
	ROM_CALL(D_ZT_STR)	; Display menu items
	pop bc
MenuLoop:
	ld a, b
	push bc
WriteNumbers:
	ld h, 0
	ld l, a
	ld (CURSOR_POS), hl	; Move cursor to 0, a
	push af			; Save a
	add a, $30			; Turn number into displayable character
	ROM_CALL(TX_CHARPUT)	; Display number
	ld a, ':'
	ROM_CALL(TX_CHARPUT)	; Display ":"
	pop af
	dec a				
	cp 0				; Does a = 0?
	jr z, WriteInverse	; If so, go to next section
	jr WriteNumbers		; Otherwise, loop again
WriteInverse:
	set 3, (iy+05)		; Choose inverse text
	pop bc
	push bc
	ld h, 0
	ld l, c
	ld (CURSOR_POS), hl	; Move cursor to 0, c
	ld a, c
	add a, $30			; Turn number into displayable character
	ROM_CALL(TX_CHARPUT)	; Display number
	ld a, ':'
	ROM_CALL(TX_CHARPUT)	; Display ":"
	res 3, (iy+05)		; Choose normal text
	pop bc
MenuKeyLoop:
	push bc
	call GET_KEY		; Get keypress
	cp G_ENTER			; Was Enter pressed?
	jr z, MenuEnter
	cp G_DOWN			; Was Down pressed?
	jr z, MenuDown
	cp G_UP			; Was Up pressed?
	jr z, MenuUp
	cp G_CLEAR			; Was Clear pressed?
	jr z, MenuQuit
	cp G_MODE			; Was Quit pressed?
	jr z, MenuQuit
	cp G_1			; Was 1 pressed?
	jr z, Menu1
	cp G_2			; Was 2 pressed?
	jr z, Menu2
	cp G_3			; Was 3 pressed?
	jr z, Menu3
	cp G_4			; Was 4 pressed?
	jr z, Menu4
	cp G_5			; Was 5 pressed?
	jr z, Menu5
	cp G_6			; Was 6 pressed?
	jr z, Menu6
	cp G_7			; Was 7 pressed?
	jr z, Menu7
	pop bc
	jr menuKeyLoop		; Not a valid key, so try again
MenuQuit:
	pop bc
	ld a, 0			; Menu cancelled, so return 0
	ret
MenuEnter:
	pop bc
	ld a, c			; Return menu item chosen
	ret
MenuDown:
	pop bc
	ld a, b
	cp c				; Already at last menu item?
	jr z, MenuKeyLoop		; If so, go back for keystroke
	inc c				; Otherwise, choose next item
	jp menuLoop			; Update display
MenuUp:
	pop bc
	ld a, c
	cp 1				; Already at first menu item?
	jr z, MenuKeyLoop		; If so, go back for keystroke
	dec c				; Otherwise, choose previous item
	jp menuLoop
Menu1:
	pop bc
	ld a, 1			; Return 1
	ret
Menu2:
	pop bc
	;call Debug
	ld a,b
	sub 2
	jp m,MenuKeyLoop
	ld a,2
	ret
Menu3:
	pop bc
	ld a,b
	sub 3
	jp m,MenuKeyLoop
	ld a,3
	ret
Menu4:
	pop bc
	ld a,b
	sub 4
	jp m,MenuKeyLoop
	ld a,4
	ret
Menu5:
	pop bc
	ld a,b
	sub 5
	jp m,MenuKeyLoop
	ld a,5
	ret
Menu6:
	pop bc
	ld a,b
	sub 6
	jp m,MenuKeyLoop
	ld a,6
	ret
Menu7:
	pop bc
	ld a,b
	sub 7
	jp m,MenuKeyLoop
	ld a,7
	ret
.list
