.nolist
; DO NOT CALL_(MULTIKEY) unless you know what you are doing.
; Use Multi_Key(alias) defined in multikey.h instead.  This part of Multi_Key
; detects the actual keypress.  Only the flags are destroyed.  Everything
; else is left alone!  Read multikey.txt for instructions on how to use this.

; Code written by Thomas J. Hruska (C) 1997 Shining Light Productions

MULTIKEY:
  push af                  ; Temporarily store af on the stack
  ld a,$FF                 ; $FF -> a
  cp b                     ; Test to see if detecting [ON] key
  jr z,DetectOnKey         ; If so, then jump to DetectOnKey
  out (1),a                ; Resets the port
  ld a,b                   ; b -> a
  out (1),a                ; Mask out most of the keys
  in a,(1)                 ; Read in a (a low bit means key is pressed)
  and c                    ; Mask out all but one key
  xor c                    ; Reverse the zero flag
  pop bc                   ; Retrieve what was af into bc
  ld a,b                   ; b -> a
  ret                      ; Return to caller

DetectOnKey:  
  ld a,%00001111           ; %00001111 -> a
  out (3),a                ; Send mask to port 3
  in a,(3)                 ; Retrieve misc. port status
  cpl                      ; Reverse all bits in a
  and %00001000            ; Mask out the [ON] key
  pop bc                   ; Retrieve what was af into bc
  ld a,b                   ; b -> a
  ret                      ; Return to caller
.list
