; Sprite Test v1.0
; Designed by Thomas J. Hruska
; (C) 1997 Shining Light Productions
; Altered for CrASH 1.3 by Cameron McCormack

#include "crash82.inc"
#include "..\\ash\\oldcall.h"
#define PIXEL_SET_OFF
#define SECOND_SET_OFF
#define BUFFER_SET_OFF
#include "multikey.h"
#include "graph2.h"

.DB "Sprite v1.0",0

CLIP_UP        =TEXT_MEM       ; Byte
CLIP_LEFT      =TEXT_MEM+1     ; Byte
CLIP_DOWN      =TEXT_MEM+2     ; Byte
CLIP_RIGHT     =TEXT_MEM+3     ; Byte

  ROM_CALL(CLEARLCD)       ; Clear the display
  call ClrGrBuf            ; Clears the graph memory
  ld bc,$0808              ; 8 -> b, 8 -> c
  ld (CLIP_DOWN),bc        ; b -> (CLIP_DOWN), c -> (CLIP_RIGHT)
  ld bc,0                  ; 0 -> b  (X position), 0 -> c  (Y position)
  ld (CLIP_UP),bc          ; b -> (CLIP_UP), c -> (CLIP_LEFT)
  ld hl,Sprite1            ; Address of Sprite1 -> hl
  ld a,%00100010           ; %00100010 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld de,$0000              ; $00 -> d, $00 -> e
  ld (CLIP_X),de           ; d -> (CLIP_X), e -> (CLIP_Y)
MainLoop:  
  call SpriteDraw          ; Call the SpriteDraw routine
  ld a,b                   ; b -> a
  add a,8                  ; a = a + 8
  ld b,a                   ; a -> b
  cp 96                    ; if a=96, then return zero
  jr nz,MainLoop           ; if not zero, then jump to MainLoop
  ld a,c                   ; c -> a
  add a,8                  ; a = a + 8
  ld c,a                   ; a -> c
  ld b,0                   ; 0 -> b
  cp 64                    ; if a=64, then return zero
  jr nz,MainLoop           ; if not zero, then jump to MainLoop
KeyLoop:
  call _GRBUFCPY_V         ; Display the Graph Buffer
  Multi_Key(KEY_24)        ; Detect if KEY_24 is being pressed
  call nz, LeftKey
  Multi_Key(KEY_25)        ; Detect if KEY_25 is being pressed
  call nz, UpKey
  Multi_Key(KEY_26)        ; Detect if KEY_26 is being pressed
  call nz, RightKey
  Multi_Key(KEY_34)        ; Detect if KEY_34 is being pressed
  call nz, DownKey
  Multi_Key(KEY_22)        ; Detect if [MODE] is being pressed
  ret nz                   ; If so, then return
  jr KeyLoop               ; Jump to KeyLoop

LeftKey:
  ld a,(CLIP_LEFT)         ; (CLIP_LEFT) -> a
  dec a                    ; a = a - 1
  cp -1                    ; If a=-1 then return zero
  jr nz,KL2                ; If not zero, then jump to KL2
  ld a,7                   ; 7 -> a
KL2:
  ld (CLIP_LEFT),a         ; a -> (CLIP_LEFT)
  ld (CLIP_X),a            ; a -> (CLIP_X)
  ld a,(CLIP_RIGHT)        ; (CLIP_RIGHT) -> a
  inc a                    ; a = a + 1
  cp 9                     ; If a=9 then return zero
  jr nz,KL3                ; If not zero, then jump to KL3
  ld a,1                   ; 1 -> a
KL3:
  ld (CLIP_RIGHT),a        ; a -> (CLIP_RIGHT)
  call ScrollRight         ; Call ScrollRight
  ld a,%00010100           ; %00010100 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,(CLIP_UP)           ; (CLIP_UP) -> a
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  ld bc,0                  ; 0 -> b, 0 -> c
  call SpriteDraw          ; Call SpriteDraw
  add a,-8                 ; a = a - 8
  neg                      ; Make a positive
  ld c,a                   ; a -> c
  ld a,%00010010           ; %00010010 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,0                   ; 0 -> a
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  ld d,7                   ; 7 -> d
KL4:
  call SpriteDraw          ; Call SpriteDraw
  ld a,8                   ; 8 -> a
  add a,c                  ; a = a + c
  ld c,a                   ; a -> c
  dec d                    ; d = d - 1
  jr nz,KL4                ; If d<>0, then jump to KL4
  ld a,%00011000           ; %00011000 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,(CLIP_DOWN)         ; (CLIP_DOWN) -> a
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  call SpriteDraw          ; Call SpriteDraw
  ret                      ; Return to caller

RightKey:
  ld a,(CLIP_LEFT)         ; (CLIP_LEFT) -> a
  inc a                    ; a = a + 1
  cp 9                     ; If a=9 then return zero
  jr nz,KR2                ; If not zero, then jump to KL2
  ld a,1                   ; 1 -> a
KR2:
  ld (CLIP_LEFT),a         ; a -> (CLIP_LEFT)
  ld a,(CLIP_RIGHT)        ; (CLIP_RIGHT) -> a
  dec a                    ; a = a - 1
  cp -1                    ; If a=-1 then return zero
  jr nz,KR3                ; If not zero, then jump to KL3
  ld a,7                   ; 7 -> a
KR3:
  ld (CLIP_RIGHT),a        ; a -> (CLIP_RIGHT)
  ld (CLIP_X),a            ; a -> (CLIP_X)
  add a,88                 ; a = a + 88
  ld b,a                   ; a -> b
  call ScrollLeft          ; Call ScrollLeft
  ld a,%00100100           ; %00100100 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,(CLIP_UP)           ; (CLIP_UP) -> a
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  ld c,0                   ; 0 -> c
  call SpriteDraw          ; Call SpriteDraw
  add a,-8                 ; a = a - 8
  neg                      ; Make a positive
  ld c,a                   ; a -> c
  ld a,%00100010           ; %00100010 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,0                   ; 0 -> a
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  ld d,7                   ; 7 -> d
KR4:
  call SpriteDraw          ; Call SpriteDraw
  ld a,8                   ; 8 -> a
  add a,c                  ; a = a + c
  ld c,a                   ; a -> c
  dec d                    ; d = d - 1
  jr nz,KR4                ; If d<>0, then jump to KL4
  ld a,%00101000           ; %00101000 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,(CLIP_DOWN)         ; (CLIP_DOWN) -> a
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  call SpriteDraw          ; Call SpriteDraw
  ret                      ; Return to caller

UpKey:
  ld a,(CLIP_UP)           ; (CLIP_UP) -> a
  dec a                    ; a = a - 1
  cp -1                    ; If a=-1 then return zero
  jr nz,KU2                ; If not zero, then jump to KL2
  ld a,7                   ; 7 -> a
KU2:
  ld (CLIP_UP),a           ; a -> (CLIP_UP)
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  ld a,(CLIP_DOWN)         ; (CLIP_DOWN) -> a
  inc a                    ; a = a + 1
  cp 9                     ; If a=9 then return zero
  jr nz,KU3                ; If not zero, then jump to KL3
  ld a,1                   ; 1 -> a
KU3:
  ld (CLIP_DOWN),a         ; a -> (CLIP_DOWN)
  call ScrollDown          ; Call ScrollDown
  ld a,%00010100           ; %00010100 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,(CLIP_LEFT)         ; (CLIP_LEFT) -> a
  ld (CLIP_X),a            ; a -> (CLIP_X)
  ld bc,0                  ; 0 -> b, 0 -> c
  call SpriteDraw          ; Call SpriteDraw
  add a,-8                 ; a = a - 8
  neg                      ; Make a positive
  ld b,a                   ; a -> b
  ld a,%00100100           ; %00100100 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,0                   ; 0 -> a
  ld (CLIP_X),a            ; a -> (CLIP_X)
  ld d,11                  ; 11 -> d
KU4:
  call SpriteDraw          ; Call SpriteDraw
  ld a,8                   ; 8 -> a
  add a,b                  ; a = a + b
  ld b,a                   ; a -> b
  dec d                    ; d = d - 1
  jr nz,KU4                ; If d<>0, then jump to KL4
  ld a,(CLIP_RIGHT)        ; (CLIP_RIGHT) -> a
  ld (CLIP_X),a            ; a -> (CLIP_X)
  call SpriteDraw          ; Call SpriteDraw
  ret                      ; Return to caller

DownKey:
  ld a,(CLIP_UP)           ; (CLIP_UP) -> a
  inc a                    ; a = a + 1
  cp 9                     ; If a=9 then return zero
  jr nz,KD2                ; If not zero, then jump to KL2
  ld a,1                   ; 1 -> a
KD2:
  ld (CLIP_UP),a           ; a -> (CLIP_UP)
  ld a,(CLIP_DOWN)         ; (CLIP_DOWN) -> a
  dec a                    ; a = a - 1
  cp -1                    ; If a=-1 then return zero
  jr nz,KD3                ; If not zero, then jump to KL3
  ld a,7                   ; 7 -> a
KD3:
  ld (CLIP_DOWN),a         ; a -> (CLIP_DOWN)
  ld (CLIP_Y),a            ; a -> (CLIP_Y)
  add a,56                 ; a = a + 56
  ld c,a                   ; a -> c
  call ScrollUp            ; Call ScrollUp
  ld a,%00011000           ; %00011000 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,(CLIP_LEFT)         ; (CLIP_LEFT) -> a
  ld (CLIP_X),a            ; a -> (CLIP_X)
  ld b,0                   ; 0 -> b
  call SpriteDraw          ; Call SpriteDraw
  add a,-8                 ; a = a - 8
  neg                      ; Make a positive
  ld b,a                   ; a -> b
  ld a,%00101000           ; %00101000 -> a
  ld (SPRITE_CODE),a       ; a -> (SPRITE_CODE)
  ld a,0                   ; 0 -> a
  ld (CLIP_X),a            ; a -> (CLIP_X)
  ld d,11                  ; 11 -> d
KD4:
  call SpriteDraw          ; Call SpriteDraw
  ld a,8                   ; 8 -> a
  add a,b                  ; a = a + b
  ld b,a                   ; a -> b
  dec d                    ; d = d - 1
  jr nz,KD4                ; If d<>0, then jump to KL4
  ld a,(CLIP_RIGHT)        ; (CLIP_RIGHT) -> a
  ld (CLIP_X),a            ; a -> (CLIP_X)
  call SpriteDraw          ; Call SpriteDraw
  ret                      ; Return to caller

#include "graph2.inc"
#include "multikey.inc"

Sprite1:
.DB 8, 8, 1               ; 8x8 with transparency
.DB %00000000             ; Actual image data
.DB %01111110
.DB %01000010
.DB %01100110
.DB %01000010
.DB %01100110
.DB %01111110
.DB %00000000

.END
