; Multi_Key Test program v1.0.  This shows off the capabilities of Multi_Key.

; Written by Thomas J. Hruska (C) 1997 Shining Light Productions
; Altered for TI-83 assembler by Cameron McCormack

#include "ti83asm.inc"
#include "multikey.h"

.ORG $9327

  call _CLRLCDFULL
  ld hl,$0000
  ld (CURROW),hl
  set 3,(IY+05)
  ld hl,Title
  call _PUTS
  res 3,(IY+05)
  ld hl,$0003
  ld (CURROW),hl
  ld hl,Main
  res 2,(IY+13)
  call _PUTS
  set 2,(IY+13)
  
KeyLoop:
  Multi_Key(KEY_24)
  call nz, LeftPressed
  Multi_Key(KEY_24)
  call z, LeftReleased
  Multi_Key(KEY_25)
  call nz, UpPressed
  Multi_Key(KEY_25)
  call z, UpReleased
  Multi_Key(KEY_26)
  call nz, RightPressed
  Multi_Key(KEY_26)
  call z, RightReleased
  Multi_Key(KEY_34)
  call nz, DownPressed
  Multi_Key(KEY_34)
  call z, DownReleased
  Multi_Key(KEY_22)
  call nz, MODEPressed
  Multi_Key(KEY_22)
  call z, MODEReleased
  Multi_Key(KEY_45)
  ret nz
  jp KeyLoop

LeftPressed:
  ld hl,$0703
DispPressed:
  ld (CURROW),hl
  ld hl,KeyOn
  call _PUTS
  ret
UpPressed:
  ld hl,$0704
  jr DispPressed
RightPressed:
  ld hl,$0705
  jr DispPressed
DownPressed:
  ld hl,$0706
  jr DispPressed
MODEPressed:
  ld hl,$0707
  jr DispPressed

LeftReleased:
  ld hl,$0703
DispReleased:
  ld (CURROW),hl
  ld hl,KeyOff
  call _PUTS
  ret
UpReleased:
  ld hl,$0704
  jr DispReleased
RightReleased:
  ld hl,$0705
  jr DispReleased
DownReleased:
  ld hl,$0706
  jr DispReleased
MODEReleased:
  ld hl,$0707
  jr DispReleased

#include "multikey.inc"

Title:
.DB " Multi-Key Test "
.DB "By Thomas Hruska"
.DB "  CLEAR  quits  ",0

Main:
.DB "Left :          "
.DB "Up   :          "
.DB "Right:          "
.DB "Down :          "
.DB "MODE :          ",0

KeyOn:  .DB "Pressed ",0
KeyOff: .DB "Released",0

.END
